//*****************************************************************
// 
//  JAVA Source for com.idautomation.pdf417; 2017
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.pdf417;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
import javax.imageio.ImageIO; //2016 BRJ
/** This is the PDF417 servlet that creates a barcode from the PDF417 class. */
public class IDAutomationServlet extends HttpServlet
{
	private boolean debug=false;
	public void init() throws ServletException { }
	// MODIFY THIS FUNCTION TO CREATE THE PDF417 USING THE request PARAMETERS
	private PDF417 getChart (HttpServletRequest request) 
	{
		PDF417 cb=new PDF417();
		if (request!=null) 
		{
                    String st = null;
                    if (request.getParameter("X")!=null) cb.X=new Double(request.getParameter("X")).doubleValue();
                    if (request.getParameter("XYR")!=null) cb.XtoYRatio=new Integer(request.getParameter("XYR")).intValue();
                    if (request.getParameter("COL")!=null) cb.PDFColumns=new Integer(request.getParameter("COL")).intValue();
                    if (request.getParameter("ROWS")!=null) cb.PDFRows=new Integer(request.getParameter("ROWS")).intValue();
                    if (request.getParameter("ECL")!=null) cb.PDFECLevel=new Integer(request.getParameter("ECL")).intValue();
                    if (request.getParameter("XYR")!=null) cb.XtoYRatio=new Integer(request.getParameter("XYR")).intValue();
                    if (request.getParameter("LEFT_MARGIN")!=null) cb.leftMarginCM=new Double(request.getParameter("LEFT_MARGIN")).doubleValue();
                    if (request.getParameter("TOP_MARGIN")!=null) cb.topMarginCM=new Double(request.getParameter("TOP_MARGIN")).doubleValue();
                    if (request.getParameter("LM")!=null) cb.leftMarginCM=new Double(request.getParameter("LM")).doubleValue();
                    if (request.getParameter("TM")!=null) cb.topMarginCM=new Double(request.getParameter("TM")).doubleValue();
                    if (request.getParameter("BC")!=null) cb.setForeground(convertColor(request.getParameter("BC")));
                    if (request.getParameter("BGC")!=null) cb.setBackground(convertColor(request.getParameter("BGC")));
                    if (request.getParameter("IR")!=null) cb.setPixelsPerCM(new Integer(request.getParameter("IR")).intValue());
                    if (request.getParameter("TRN")!=null) cb.truncated=(request.getParameter("TRN").compareTo("Y")==0);
                    if (request.getParameter("ROTATE")!=null) cb.rotate=new Integer(request.getParameter("ROTATE")).intValue();
                    if (request.getParameter("O")!=null) cb.rotate=new Integer(request.getParameter("O")).intValue();
                    if (request.getParameter("BARCODE")!=null) cb.code=request.getParameter("BARCODE");
                    if (request.getParameter("D")!=null) cb.code=request.getParameter("D");
                    if (request.getParameter("MODE")!=null) 
                    {
                        st = (request.getParameter("MODE"));
                        if (st.toUpperCase().compareTo("BINARY")==0 || st.compareTo("0")==0)	cb.PDFMode=cb.PDF_BINARY;
                        if (st.toUpperCase().compareTo("TEXT")==0 || st.compareTo("1")==0)	cb.PDFMode=cb.PDF_TEXT;
                        if (st.toUpperCase().compareTo("NUMERIC")==0 || st.compareTo("2")==0)	cb.PDFMode=cb.PDF_NUMERIC;
                    }
                    if (request.getParameter("PT")!=null)
                    {
                        String PTParameter = request.getParameter("PT");
                        if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                           PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                            cb.processTilde = true;
                        else
                            cb.processTilde = false;
                    }
                    if (request.getParameter("MAF")!=null) cb.MacroPDFFileID=new Integer(request.getParameter("MAF")).intValue();
                    if (request.getParameter("MAS")!=null) cb.MacroPDFSegmentIndex=new Integer(request.getParameter("MAS")).intValue();
                    if (request.getParameter("MAE")!=null)
                    {
                        String PTParameter = request.getParameter("MAE");
                        if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                           PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                            cb.MacroPDFEnable = true;
                        else
                            cb.MacroPDFEnable = false;
                    }
                    if (request.getParameter("MAL")!=null)
                    {
                        String PTParameter = request.getParameter("MAL");
                        if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                           PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                            cb.MacroPDFLastSegment = true;
                        else
                            cb.MacroPDFLastSegment = false;
                    }
		}
		else  
		{
			cb.code="No Data";
		}
		return cb;
	}
        
        public java.awt.Color convertColor(String c) 
        {
            if (c.toUpperCase().compareTo("NULL")==0) return null;
            if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
            if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
            if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
            if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
            if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
            if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
            if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
            if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
            if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
            if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
            if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
            if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
            if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
            try 
            {
                return java.awt.Color.decode(c);
            } 
            catch (Exception e) 
            {
                return java.awt.Color.black;
            }
        }
	// Handle a request
	// 1. create PDF417
	// 2. draw PDF417 in a Buffered Image
	// 3. encode image as GIF or JPEG and send it to the browser
	public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
	{
		PrintWriter out;
		ServletOutputStream outb;
		String encode="gif";
		if (request!=null) 
		{
			if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();
                        if (request.getParameter("I")!=null)  encode=request.getParameter("I").toLowerCase();
			if (encode.compareTo("gif")!=0) encode="jpeg";
		}
		response.setContentType("image/"+encode);
		outb=response.getOutputStream();
		// avoid caching in browser
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		response.setDateHeader ("Expires",0);
		try 
		{	// Create buffer
			//the default height and width if not specified.
			int w=200;
			int h=80;
			// get PDF417
			PDF417 cb=getChart(request);
			if ((request!=null) && (request.getParameter("WIDTH")!=null) && (request.getParameter("HEIGHT")!=null)) 
			{
                            w=new Integer(request.getParameter("WIDTH")).intValue();
                            h=new Integer(request.getParameter("HEIGHT")).intValue();
			}
                        else if ((request!=null) && (request.getParameter("W")!=null) && (request.getParameter("H")!=null)) 
                        {
                            cb.autoSize = false;
                            w=new Integer(request.getParameter("W")).intValue();
                            h=new Integer(request.getParameter("H")).intValue();
                        }
			else 
			{
				//a temp image must be created to find the preferred size
				cb.autoSize=true;
				cb.setSize(170,90);
				java.awt.image.BufferedImage imageTemp = new java.awt.image.BufferedImage( cb.getSize().width,cb.getSize().height,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
				java.awt.Graphics imgTempGraphics = imageTemp.createGraphics();
				cb.paint(imgTempGraphics);
				cb.invalidate();
				w=cb.getSize().width;
				h=cb.getSize().height;
				imgTempGraphics.dispose();
			}
			java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
			java.awt.Graphics2D BarGraphics=BarImage.createGraphics();
			if (debug) System.out.println("Size: "+w+" "+h);
			cb.setSize(w,h);
			cb.paint(BarGraphics);
			if (encode.compareToIgnoreCase("gif")==0) 
			{
				// encode buffered image to a gif
				com.idautomation.pdf417.encoder.GifEncoder encoder = new com.idautomation.pdf417.encoder.GifEncoder(BarImage  ,outb);
				encoder.encode();
			}
			else
			{
				/// open file
           // java.io.File f=new java.io.File(sFile);
           // f.delete();
          //  java.io.FileOutputStream of=new java.io.FileOutputStream(f);

            // encode buffered image to a jpeg
            //com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(of ); BRJ 9/2016 Not compatible with Java 7
            //increase the JPEG quality to 100%
            //com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( image ); BRJ 9/2016 Not compatible with Java 7
			//param.setQuality(1.0F,true);
            //encoder.setJPEGEncodeParam(param); BRJ 9/2016 Not compatible with java 7. Java 7 now uses ImageIO.write
            // encoder.encode( image,param ); 
		    
			ImageIO.write(BarImage, "jpeg", outb);  //BRJ Replaces com.sun.image.codec for Java version 1.4 and up.  9/2016
          //  of.close();	

			}
		} catch (Exception e) { e.printStackTrace();}
	}

	public void doPost (HttpServletRequest request, HttpServletResponse response) throws ServletException
	{
		try 
		{
			doGet(request,response);
		} 
			catch (Exception e) { e.printStackTrace();}
	}

}
